package net.wanji.utc.hisense.task;

import net.wanji.common.utils.tool.StringUtils;
import net.wanji.databus.vo.LightsStatusVO;
import net.wanji.utc.hisense.cache.SignalDataCache;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.Map;
import java.util.Objects;

/**
 * @author duanruiming
 * @date 2023/09/20 14:25
 */
@Component
public class HisensePhaseCountDownTask {

    @Scheduled(fixedRate = 1000, initialDelay = 1000)
    public void phaseTimeCountDown() {
        Map<String, LightsStatusVO> runningStateInfoCache4DataBrain = SignalDataCache.runningStateInfoCache4DataBrain;
        Map<String, Long> runningStatusStampMap = SignalDataCache.runningStatusStampMap;
        if (!runningStateInfoCache4DataBrain.isEmpty()) {
            for (Map.Entry<String, LightsStatusVO> entry : runningStateInfoCache4DataBrain.entrySet()) {
                String crossId = entry.getKey();
                LightsStatusVO lightsStatusVO = entry.getValue();
                String schemeStartTime = lightsStatusVO.getSchemeStartTime();
                Long lastPhaseTimeStamp = runningStatusStampMap.get(crossId);
                if (Objects.nonNull(lastPhaseTimeStamp) && StringUtils.equalsIgnoreCase(schemeStartTime, String.valueOf(lastPhaseTimeStamp))) {
                    lightsStatusVO.setCycleCountDown(lightsStatusVO.getCycleCountDown() - 1);
                    runningStateInfoCache4DataBrain.put(crossId, lightsStatusVO);
                }
            }
        }

    }
}
